Uses
  Startup, IniServ, TimeOut, Dialogs, App, StdDlg, Objects, Views, Strings,
  Dos, Drivers, MsgBox, Tools, ColorTxt, Menus, Printer, Arc, Canonic;

{$V-}

const
  cmAddItem     = 101;
  cmDeleteItem  = 201;
  cmLoadColl    = 202;
  cmSaveColl    = 203;
  cmAddCurrent  = 204;
  cmItemPressed = 205;
  cmSelectItem  = 206;
  cmAbout       = 207;
  cmPrintList   = 208;
  CfgFileHeader = 'Configuration file for locker ver 1.1'#10#13+
                  'Copyrigth (C) Glory Software. All Rigth Reserved. 1994-96 year.';

{ ⠭ file protect }
  fpOpen    = $0001;
  fpDelete  = $0002;
  fpRun     = $0004;

Type
  PLockedObj = ^TLockedObj;
  TLockedObj = Object(TObject)
    Path: PathStr;
    Mode: Byte;     { 樨 fpXXXX ⠭ }
    Constructor Init(P:String; M: Byte);
  End;

  { This Collection assumed TLockedObj inside }
  PLockedCollection = ^TLockedCollection;
  TLockedCollection = Object(TCollection)
    Constructor Load(var S: TStream);
    { ஢    store }
    Procedure Store(var S: TStream); Virtual;
    {   insert'e ஢ઠ WILDCARD }
    Procedure Insert(Item: Pointer); Virtual;
  End;

  PFileObj = ^TFileObj;
  TFileObj = Object(TObject)
    isSelect: Boolean;
    FName: String;
    Constructor Init(S: String);
  End;

  PFileLB = ^TFileLB;
  TFileLB = Object(TCommandLB)
    Function  GetText(Item: Integer; MaxLen: Integer): String; Virtual;
    Procedure HandleEvent(var Event: TEvent); Virtual;
    Procedure SetSelect(Mode: Boolean);
    Function  isMarked: Boolean;
    Function  isSelected(Item: Integer): Boolean; Virtual;
  End;

  PSelectListBox = ^TSelectListBox;
  TSelectListBox = Object(TListBox)
    Function  GetText(Item: Integer; MaxLen: Integer): String; Virtual;
    Procedure FocusItem(Item: Integer); Virtual;
    Procedure DeleteItem;
    Procedure Print;
  End;

  PModeCheckBox = ^TModeCheckBox;
  TModeCheckBox = Object(TCheckBoxes)
    Procedure Press(Item: Integer); Virtual;
  End;

  PChangesDirListBox = ^TChangesDirListBox;
  TChangesDirListBox = Object(TDirListBox)
    Procedure SetState(AState: Word; Enable: Boolean); Virtual;
  End;

  PD = ^TD;
  TD = Object(TDialog)
    LB: PChangesDirListBox;
    FileList: PFileLB;
    IL: PInputLine;
    xCol: PLockedCollection;
    SelectList: PSelectListBox;
    Changes: Boolean;
    CB: PModeCheckBox;
    Constructor Init;
    Destructor Done; Virtual;
    Procedure HandleEvent(var Event: TEvent); Virtual;
    Function GetFileList(Path: DirStr): PCollection;
    Procedure StoreSelectList;
    Function LoadSelectList: PLockedCollection;
  End;

  T = Object(TGadGetsApp)
    Procedure Run; Virtual;
    Procedure InitStatusLine; Virtual;
  End;

Procedure TChangesDirListBox.SetState(AState: Word; Enable: Boolean);
Begin
  TListBox.SetState(AState, Enable);
End;

Constructor TFileObj.Init;
Begin
  Inherited Init;
  FName := S;
  isSelect := False;
End;

Constructor TLockedObj.Init;
Begin
  Inherited Init;
  Path := P;
  Mode := M;
End;

Constructor TLockedCollection.Load(var S: TStream);
Var
  O: PLockedObj;
  P: String;
  C: Char;
  i: Byte;
  fpMode: Byte;
Begin
  Inherited Init(10, 2);
  S.Read(P, Length(CfgFileHeader));
  While S.Status = stOk do
  Begin
    S.Read(C, 1);
    if C <> #$B0 then
    Begin
      { Problems! }
      Break;
    End;
    P := '';
    i := 0;
    Repeat
      S.Read(C, 1);
      if C = #0 then
      Begin
         S.Read(C, 1);
         fpMode := Byte(C);
         Break;
      End;
      P := P + C;
      Inc(i);
      if i > 253 then
         Break;
    Until False;
    P[0] := Chr(i);
    Insert(New(PLockedObj, Init(P, fpMode)));
  End;
End;

Procedure TLockedCollection.Store(var S: TStream);
Var
  P: String;
  i: Word;
  C: Byte;
  A,B: PChar;
Begin
  P := CfgFileHeader;
  S.Write(P[1], Length(CfgFileHeader));
  if Count > 0 then
  For i := 0 to Count - 1 do
  Begin
    C := $B0;
    S.Write(C, 1);
    P := PLockedObj(At(i))^.Path;
    { P -  }
    StrPCopy(A, P);
    CanonizedFileName(A, B);
    P := StrPas(B);
    S.Write(P[1], Byte(P[0]));
    C := 0;
    S.Write(C, 1);
    S.Write(PLockedObj(At(i))^.Mode, 1);
  End;
End;

Procedure TLockedCollection.Insert(Item: Pointer);
Var
  D: DirStr;
  Function IsPresentDir(Item: PLockedObj): Boolean; Far;
  Begin

  End;
Begin
  { । ⥬,  ⠢ - ஢    ᯨ᪥ }
  Inherited Insert(Item);
End;

Function TD.GetFileList(Path: DirStr): PCollection;
Var
  C: PCollection;
  F: SearchRec;
  S: String;
Begin
 C := New(PCollection, Init(10, 2));
 S := Path;
 if S[Length(S)] <> '\' then
    S := S + '\';
 FindFirst(IL^.DATA^, Archive or ReadOnly or Hidden or SysFile, F);
 While DosError = 0 do
 begin
   C^.Insert(New(PFileObj, Init(F.Name)));
   FindNext(F);
 end;

 if C^.Count = 0 then
 Begin
   Application^.DisableCommands([cmAddItem]);
   C^.Insert(New(PFileObj, Init(' 䠩')));
   FileList^.Options := FileList^.Options and Not ofSelectable;
 End
 else
 Begin
   Application^.EnableCommands([cmAddItem, cmAddCurrent]);
   FileList^.Options := FileList^.Options or ofSelectable;
 End;
 GetFileList := C;
End;

Constructor TD.Init;
Var
  R: TRect;
  S: String;
  V: PView;
Begin
  R.Assign(0, 0, 68, 23);
  Inherited Init(R, 'Setup for locker');
  Options := Options or ofCentered;

  R.Assign(1, 2, 46, 3);
  IL := New(PInputLine, Init(R, 60));
  Insert(IL);

  R.Move(0, -1);
  Insert(New(PLabel, Init(R, ' 䠩',IL)));

  R.Assign(30, 4, 31, 14);
  V := New(PScrollBar, Init(R));
  Insert(V);

  R.Assign(1, 4, 30, 14);
  LB := New(PChangesDirListBox, Init(R, PScrollBar(V)));
  Insert(LB);
  GetDir(0, S);
  IL^.Data^ := S + '\*.*';
  LB^.NewDirectory(S);
  LB^.Options := LB^.Options or ofFramed;

  R.Assign(1, 3, 19, 4);
  Insert(New(PLabel, Init(R, 'ॢ ⠫', LB)));

  R.Assign(46, 4, 47, 14);
  V := New(PScrollBar, Init(R));
  Insert(V);

  R.Assign(31, 4, 46, 14);
  FileList := New(PFileLB, Init(R, 1, PScrollBar(V), cmAddCurrent));
  Insert(FileList);
  FileList^.NewList(GetFileList(S));
  FileList^.Options := FileList^.Options or ofFramed;

  R.Assign(31, 3, 45, 4);
  Insert(New(PLabel, Init(R, '᮪ 䠩', FileList)));

  R.Assign(66, 16, 67, 22);
  V := New(PScrollBar, Init(R));
  Insert(V);
  R.Assign(1, 16, 66, 22);
  SelectList := New(PSelectListBox, Init(R, 1, PScrollBar(V)));
  Insert(SelectList);
  R.Assign(1, 15, 66, 16);
  Insert(New(PLabel, Init(R, '࠭                                                   ODE', SelectList)));

  R.Assign(50, 2, 64, 4);
  Insert(New(PButton, Init(R, '~A~dd', cmAddItem, bfNormal)));

  R.Move(0, 2);
  Insert(New(PButton, Init(R, '~D~elete', cmDeleteItem, bfNormal)));

  R.Move(0, 2);
  Insert(New(PButton, Init(R, '~L~oad list', cmLoadColl, bfNormal)));

  R.Move(0, 2);
  Insert(New(PButton, Init(R, '~S~ave list', cmSaveColl, bfNormal)));

  R.Move(0, 2);
  Insert(New(PButton, Init(R, '~C~lose', cmOk, bfNormal)));


  R.Move(-2, 2);
  Inc(R.B.X, 4);
  Inc(R.B.Y);
  CB := New(PModeCheckbox, Init(R,
    NewSItem('~O~pen File',
    NewSItem('Delete ~F~ile',
    NewSItem('~E~xecute File', Nil)))));
  Insert(CB);

  xCol := LoadSelectList;
  SelectList^.NewList(xCol);

  SelectNext(False);

End;

Destructor TD.Done;
Begin
  FileList^.NewList(Nil);
  LB^.NewList(Nil);
  SelectList^.NewList(Nil);
  Inherited Done;
End;

Function TD.LoadSelectList: PLockedCollection;
Var
  C: PLockedCollection;
  S: TBufStream;
Begin
  S.Init('locker.cfg', stOpenRead, 2048);
  C := New(PLockedCollection, Load(S));
  S.Done;
  LoadSelectList := C;
  Changes := False;
End;

Procedure TD.StoreSelectList;
Var
  S: TBufStream;
Begin
  S.Init('locker.cfg', stCreate, 2048);
  xCol^.Store(S);
  S.Done;
  Changes := False;
End;

Procedure TD.HandleEvent;
  Procedure AppendCurrentItem;
  Var
    S: String;
  Begin
    if (FileList^.Options and ofSelectable) = 0 then
       Exit;
    S := LB^.Dir;
    if S[Length(S)] = '\' then
       Dec(S[0]);
    S := S + '\' + PFileObj(FileList^.List^.At(FileList^.Focused))^.FName;
    SelectList^.List^.Insert(New(PLockedObj, Init(S, Byte(CB^.Value))));
    SelectList^.SetRange(SelectList^.Range+1);
    SelectList^.FocusItem(SelectList^.Range-1);
    Changes := True;
    ReDraw;
  End;

  Procedure AppendSelectList;
  Var
    I: Word;
    S: String;
  Begin
    if FileList^.isMarked then
    Begin
      For i := 0 to FileList^.Range - 1 do
      if PFileObj(FileList^.List^.At(i))^.isSelect then
      Begin
       S := LB^.Dir;
       if S[Length(S)] = '\' then
          Dec(S[0]);
        S := S + '\' + PFileObj(FileList^.List^.At(i))^.FName;
        SelectList^.List^.Insert(New(PLockedObj, Init(S, Byte(CB^.Value))));
        SelectList^.SetRange(SelectList^.Range+1);
        PFileObj(FileList^.List^.At(i))^.isSelect := False;
        SelectList^.DrawView;
        SelectList^.FocusItem(SelectList^.Range-1);
      End;
      Changes := True;
    End
    else
    Begin
       S := IL^.Data^;
       SelectList^.List^.Insert(New(PLockedObj, Init(S, Byte(CB^.Value))));
       SelectList^.SetRange(SelectList^.Range+1);
       SelectList^.FocusItem(SelectList^.Range-1);
       Changes := True;
    End;
    ReDraw;
  End;

var
  CurDir: DirStr;
  D, N, E: String;
  P: PDirEntry;
  C: PLockedCollection;
  W: Word;
  B: Byte;
begin
  if Event.What = evBroadCast then
  Begin
    Case Event.Command of
      cmItemPressed: Begin
                       if SelectList^.Range = 0 then Exit;
                       B := Byte(Event.InfoPtr^);
                       PLockedObj(SelectList^.List^.At(SelectList^.Focused))^.Mode :=
                       PLockedObj(SelectList^.List^.At(SelectList^.Focused))^.Mode xor
                          ($0001 shl B);
                       SelectList^.DrawView;
                       ClearEvent(Event);
                     End;
      cmSelectItem:  Begin
                       CB^.SetData(Word(Event.InfoPtr^));
                       CB^.DrawView;
                       ClearEvent(Event);
                     End;
    End;
  End;

  if Event.What = evKeyDown then
    if (Event.KeyCode = kbEnter) then
    Begin
      if Current = PView(IL) then
      Begin
        if IL^.Data^ = '' then
           IL^.Data^ := '*.*';
        IL^.Data^ := UpperCase(IL^.Data^);
        FSplit(IL^.Data^, D, N, E);
        if D = '' then
        Begin
           Message(@Self, evCommand, cmChangeDir, Nil);
           SelectNext(False);
           exit;
        End;
        if PathValid(D) then
        Begin
           if N = '' then
              N := '*';
           if E = '' then
              E := '.*';
           if D[Length(D)] <> '\' then
              D := D + '\';
           IL^.Data^ := D + N + E;
           LB^.NewDirectory(D);
           FileList^.NewList(GetFileList(CurDir));
           LB^.DrawView;
           SelectNext(False);
        End
        else
          MessageBox(^C'Illegal directory!', Nil, mfError + mfOkButton)
      End
      else
      if Current = PView(LB) then
        Message(@Self, evCommand, cmChangeDir, Nil)
      else
      if Current = PView(FileList) then
        AppendCurrentItem;
    End
    else
    if Event.KeyCode = kbEsc then
    Begin
      Message(@Self, evCommand, cmOk, Nil);
      ClearEvent(Event)
    End
    else
    if (Event.KeyCode = kbDel) and (Current = PView(SelectList)) then
       SelectList^.DeleteItem;

  if Event.What = evCommand then
  Case Event.Command of
    cmChangeDir: begin
                   P := LB^.List^.At(LB^.Focused);

                   if (P^.Directory^ = Drives^) or
                   DriveValid(P^.Directory^[1]) then
                      CurDir := P^.Directory^
                   else
                      Exit;

                   if (Length(CurDir) > 3) and
                   (CurDir[Length(CurDir)] = '\') then
                      Dec(CurDir[0]);
                      { CurDir := Copy(CurDir,1,Length(CurDir)-1); }

                   LB^.NewDirectory(CurDir);

                   { ⠭  DIR  Input Line }
                   if CurDir = Drives^ then
                     IL^.Data^ := ''
                   else
                   Begin
                     FSplit(IL^.Data^, D, N, E);
                     if N = '' then
                        N := '*';
                     if E = '' then
                        E := '.*';
                     if CurDir[Length(CurDir)] = '\' then
                        Dec(CurDir[0]);
                     IL^.Data^ := CurDir + '\' + N + E;
                   End;
                   FileList^.NewList(GetFileList(CurDir));
                   ReDraw;
                 end;
    cmAddItem: AppendSelectList;
    cmAddCurrent: AppendCurrentItem;
    cmDeleteItem: SelectList^.DeleteItem;
    cmPrintList: SelectList^.Print;
    cmLoadColl: Begin
                    C := LoadSelectList;
                    SelectList^.NewList(C);
                    xCol := C;
                    ReDraw;
                  End;
    cmSaveColl: StoreSelectList;
    cmOk, cmClose, cmCancel:
      if Changes then
      Begin
        W := MessageBox(^C'࠭ ?', Nil, mfConfirmation+mfYesNoCancel);
        Case W of
          cmYes:StoreSelectList;
          cmCancel: ClearEvent(Event);
          cmNo: EndModal(cmOk);
        End;
      End;
  End;

  Inherited HandleEvent(Event);
end;

Function TFileLB.GetText(Item: Integer; MaxLen: Integer): String;
const
  sFormat = '%1s%-12s';
  sSelect = '';
var
  S, J: String;
  SR: PFileObj;
  aParam: array[0..1] of Pointer;
begin
  SR := PFileObj(List^.At(Item));
  if SR^.isSelect then
    J := sSelect
  else
    J := ' ';
  aParam[0] := @J;
  aParam[1] := @SR^.FName;
  FormatStr( S, sFormat, aParam );
  GetText := Copy( S, 1, MaxLen );
end;

Function TFileLB.isSelected(Item: Integer): Boolean;
Begin
  isSelected := PFileObj(List^.At(Item))^.isSelect;
End;

Procedure TFileLB.HandleEvent;
Begin
  if Event.What = evMouseDown then
  if Event.Buttons = mbRightButton then
  Begin
     Inherited HandleEvent(Event);
     SetSelect(False);
     Exit;
  End;
  if Event.What = evKeyDown then
  if Event.KeyCode = kbIns then
  Begin
     SetSelect(True);
     Exit;
  End;

  Inherited HandleEvent(Event);
End;

Procedure TFileLB.SetSelect(Mode: Boolean);
Begin
  PFileObj(List^.At(Focused))^.isSelect :=
    Not PFileObj(List^.At(Focused))^.isSelect;
  if Mode and (Focused <> Range - 1) then
     FocusItem(Focused+1);
  DrawView;
End;

Function TFileLB.isMarked: Boolean;
  Function WhatSel(Item:PFileObj):Boolean; Far;
  Begin
    WhatSel := Item^.isSelect;
  End;
Begin
  isMarked := List^.FirstThat(@WhatSel) <> Nil;
End;

Function TSelectListBox.GetText(Item: Integer; MaxLen: Integer): String;
const
  sFormat = '%-57s %1s%1s%1s';
  insChar:String[1] = 'X';
  noinsChar:String[1] = ' ';
var
  SR: PLockedObj;
  aParam: Array[0..3] of Pointer;
  S: String;
  i: Byte;
begin
  SR := PLockedObj(List^.At(Item));
  aParam[0] := @SR^.Path;

  For i := 0 to 2 do
  if ((SR^.Mode shr i) and $0001) <> 0 then
     aParam[i+1] := @insChar
  else
     aParam[i+1] := @noinsChar;

  FormatStr( S, sFormat, aParam );
  GetText := Copy( S, 1, MaxLen );
end;

Procedure TSelectListBox.DeleteItem;
Begin
  if Range > 0 then
  Begin
    List^.AtFree(Focused);
    SetRange(Range-1);
    if (Focused = Range) And (Range > 0) then
       FocusItem(Range-1);
    DrawView;
    PD(Owner)^.Changes := True;
  End
End;

Procedure TSelectListBox.FocusItem(Item: Integer);
Begin
  Inherited FocusItem(Item);
  Message(Owner, evBroadCast, cmSelectItem,
          @PLockedObj(List^.At(Item))^.Mode);
End;

Procedure TSelectListBox.Print;
  Procedure PrintItem(Item: PLockedObj); Far;
  const
    sFormat = '%-57s %1s%1s%1s';
    insChar:String[3] = 'ODE';
    noinsChar:String[1] = ' ';
  Var
    aParam: Array[0..3] of Pointer;
    AS: Array[1..3] of String[1];
    S: String;
    i: Byte;
  Begin
    With Item^ do
    Begin
      aParam[0] := @Path;
      For i := 0 to 2 do
      if ((Mode shr i) and $0001) <> 0 then
      Begin
         As[i] := insChar[i+1];
         aParam[i+1] := @As[i]
      End
      else
         aParam[i+1] := @noinsChar;
    End;
    FormatStr( S, sFormat, aParam );
    WriteLn(Lst, S);
  End;
Begin
  While PrintStatus <> 144 do
     if MessageBox(^C'pp  ⮢. p?', Nil,
                      mfError + mfYesNo) <> cmYes
     then Exit;
   List^.ForEach(@PrintItem);
End;

Procedure TModeCheckBox.Press;
Begin
  Inherited Press(Item);
  Message(Owner, evBroadCast, cmItemPressed, @Item);
End;

Procedure T.Run;
Begin
  ExecuteDialog(New(PD, Init), Nil);
End;

procedure T.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  StatusLine := New(PStatusLine, Init(R,
    NewStatusDef(0, $FFFF,
      NewStatusKey('~Alt-C~ 室', kbNoKey, cmOK,
      NewStatusKey('~F5~  ᯨ᮪', kbF5, cmPrintList,
      nil)),
    nil)));
end;

Var
  A: T;

Begin
  LoadProfile('lsetup.ini');
  A.Init;
  A.Run;
  A.Done;
End.